function rml100k = expe_realML100k_2() 
% Script for producing matrix completion results on real data. 
%
% Reference: 
% S. Dong, P.-A. Absil, and K. A. Gallivan. Riemannian gradient descent methods
% for graph-regularized matrix completion}}, Preprint, (2019), pp.1--41,
% https://sites.uclouvain.be/absil/2019.06. 
% 
% Contact: Shuyu Dong (shuyu.dong@uclouvain.be).
%
datanames = {'traffic', 'lmafitML100k', 'lmafitML1M', 'pwsmooth'};
dataset = datanames{2};
methods_init = {'random','M0'};
method_init = methods_init{2};

switch dataset
    case {'lmafitML100k','lmafitML1M'} 
    SR_MIN = 0.8;
    SR_MAX = 0.8;
    SR_N   = 1;

    rml100k = Tester(dataset,...
            'sampl_rate',   linspace(SR_MIN, SR_MAX, SR_N),...
            'use_submatrix',false, 'dims_submatrix', [nan, nan],...
            'fromSideinfo', ones(numel(Tester.DEFAULT_buildLmat.methodname),1)...
            );
    % the option 'fromSideinfo' is 

end


Nmethods   = Tester.N_METHODS; 
DOCROSSVAL = zeros(Nmethods, 1); 
WILLRUN    = zeros(Nmethods, 1);
WILLRUN_mul    = zeros(Nmethods, 1);

% List of manifold-pbtype: see GRLRMC.NAMES_MAN
% 1 'GH_Euc', ...
% 2 'USV_embeded', ...
% 3 'GH_qprecon',... % 'GH_EucCruderls',...
% 4 'GH_qpreconExa',...
% 5 'GH_qleftinv', ...
% 6 'GH_qleftinvExa'};

% List of algorithms: see Solver.NAMES_ALGO
% 1 'GRALS';...
% 2 'GRALS1';...
% 3 'GRALS2';...
% 4 'RSD_MANOPT';...
% 5 'RCG_MANOPT';...
% 6 'RCGprecon_MANOPT'; ...
% 7 'RSD'; 
% 8 'RCG'}

% List of linesearch methods: see Solver.NAMES_LS
% 1 'lsArmijo'; ...
% 2 'lsFree';...
% 3 'lsBB';...
% Will test: 
% Domain        Algo        SS-type             line-search 
% -------------------------------------------------------------
% Euc           GRALS1         -                -         ..........1 
% Euc           GRALS2         -                -         ..........1
% Euc           RSD-manopt  linemin (Eq.(30))   lsArmijo ...........1 
% Euc           RCG-manopt  linemin             lsArmijo ...........1
% QpreconExa    RSD-manopt  linemin             lsArmijo  ..........1
% QpreconExa    RCG-manopt  linemin             lsArmijo  ..........1
% Qprecon~      RSD         linemin             lsFree    ..........1
% Qprecon~      RCG         linemin             lsFree    ..........1
% Qprecon~      RSD         one (s_t\equiv 1)   lsArmijo ...........1
% Qleftin~      RSD         linemin             lsFree    ..........1
% Qleftin~      RCG         linemin             lsFree    ..........1

IDS_MAN =       [1 1 1 1 4 4 4 4 4 6 6 1 1 ] ;
IDS_ALG =       [2 3 4 5 4 5 7 8 7 7 8 9 10] ;
IDS_SS0 =       [1 1 1 1 1 1 1 1 2 1 1 1 1 ] ;
IDS_LS =        [1 1 1 1 1 1 2 2 1 2 2 1 1 ] ;

WILLRUN =       [1 1 1 1 0 0 1 1 1 1 1 1 1];
WILLRUN_mul =   [0 0 0 0 0 0 0 0 0 0 0 0 0];
doCrossval = repmat(0,[1,numel(WILLRUN)]); 

TOLGRADNORM = 1e-14;
NEPOCH = 600;
N_REPEATTESTS = 1;

% Lower-bound of \alpha in log scale 
LAMBDA = -0.5;
% Lower-bound of \gamma_r in log scale  
GAMMAr = -2;  
GAMMAr2 = log10(2); 
RANK   = 10; 
HP_NCONFIGS = 20;

%% the problem parameters and information of methods to test
tab_hp = rml100k.gen_tableHp3_('alpha_r',      [LAMBDA;LAMBDA+2],...
                        'Lreg_gammar',  [GAMMAr; GAMMAr2],...
                        'rank',         [RANK;RANK], ...
                        'hp_nconfigs',  HP_NCONFIGS  );

info_methods = Tester.gen_infoMethods2(Tester.parseArgs('infoMethods2',...
                                'ids_man',          IDS_MAN, ...
                                'ids_alg',          IDS_ALG, ...
                                'ids_ls',           IDS_LS, ...
                                'ids_ss0',          IDS_SS0, ...
                                'doCrossval2',         doCrossval,...
                                'willRun2',            WILLRUN,...
                                'willRun2_multiphase', WILLRUN_mul) );
% rml100k.info_methods = info_methods; 
% return; 
%%

rml100k.run_tester_2(tab_hp, ...
                'ids_man',          IDS_MAN, ...
                'ids_alg',          IDS_ALG, ...
                'ids_ss0',          IDS_SS0, ...
                'ids_ls',           IDS_LS, ...
                'doCrossval2',         doCrossval,...
                'willRun2',            WILLRUN,...
                'willRun2_multiphase', WILLRUN_mul,...
                'repeatTests_tolGrad', TOLGRADNORM,...
                'tolgradnorm',         TOLGRADNORM,...
                'n_epoch',             NEPOCH, ... 
                'n_repeatTests',       N_REPEATTESTS);

end

